<template>
  <div v-loading="loading">
    <CDataTable
      hover
      :items="data"
      :fields="FIELDS"
      class="item-table"
    >
      <template #box="{item}">
        <td>
          {{ item.box.name }}
        </td>
      </template>

      <template #status="{item}">
        <td>
          {{ item.status }}
        </td>
      </template>

      <template #action="{ item }">
        <td class="white-space-nowrap">
          <CButton size="sm" color="primary" @click="showDetail(item.id)">
            細部
          </CButton>
        </td>
      </template>
    </CDataTable>
  </div>
</template>

<style lang="scss" scoped>
  .item-table {
    /deep/ {
      table {
        border-bottom: 1px solid #d8dbe0;
        margin-bottom: 0;
        thead {
          tr {
            th {
              &.action {
                width: 80px;
              }
            }
          }
        }
      }
    }
  }
</style>

<script>
const EVENT_DETAIL = 'detail'

const FIELDS = [
  { key: 'id', label: 'ID', _classes: 'id' },
  { key: 'name', label: '品名', _classes: 'name' },
  { key: 'box', label: '箱番', _classes: 'box' },
  { key: 'starting_price', label: 'startingPrice', _classes: 'startingPrice' },
  { key: 'current_price', label: 'currentPrice', _classes: 'expectedPrice' },
  { key: 'expected_price', label: 'expectedPrice', _classes: 'expectedPrice' },
  { key: 'number', label: 'number', _classes: 'number' },
  { key: 'status', label: 'status', _classes: 'status' },
  { key: 'note', label: '備考', _classes: 'note' },
  { key: 'action', label: 'Action', _classes: 'action' }
]

export default {
  props: {
    /**
     * Item list
     */
    data: {
      type: Array,
      default: () => []
    },

    /**
     * Loading status
     */
    loading: {
      type: Boolean,
      default: false
    }
  },

  computed: {
    /**
     * Get FIELDS of header table
     *
     * @return {array} FIELDS of header table
     */
    FIELDS () {
      return FIELDS
    }
  },

  methods: {
    /**
     * Show detail
     *
     * @param {String} id - Item id
     */
    showDetail (id) {
      this.$emit(EVENT_DETAIL, id)
    }
  }
}
</script>
